// Emacs style mode select   -*- C++ -*-
// -----------------------------------------------------------------------------
// ########   ###### #####   #####  ######   ######  ######
// ##     ##  ##     ##  ## ##  ## ##    ## ##    ## ##   ##
// ##     ##  ##     ##   ###   ## ##    ## ##    ## ##    ##
// ########   ####   ##    #    ## ##    ## ##    ## ##    ##
// ##    ##   ##     ##         ## ##    ## ##    ## ##    ##
// ##     ##  ##     ##         ## ##    ## ##    ## ##   ##
// ##      ## ###### ##         ##  ######   ######  ######
//                      http://remood.sourceforge.net/
// -----------------------------------------------------------------------------
// Project Leader:    GhostlyDeath           (ghostlydeath@gmail.com)
// Project Co-Leader: RedZTag                (jostol27@gmail.com)
// Members:           Demyx                  (demyx@endgameftw.com)
// -----------------------------------------------------------------------------
// Copyright (C) 2008-2009 The ReMooD Team.
// -----------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// -----------------------------------------------------------------------------
// DESCRIPTION: Master Server

#include "global.h"

Int8 NET_ReadInt8(Int8** Ptr)
{
	Int8 Ret;
	
	if (!Ptr || !(*Ptr))
		return 0;
	
	Ret = **Ptr;
	(*Ptr)++;
	return Ret;
}

Int16 NET_ReadInt16(Int16** Ptr)
{
	Int16 Ret;
	
	if (!Ptr || !(*Ptr))
		return 0;
	
	Ret = **Ptr;
	(*Ptr)++;
	return NATIVE16(Ret);
}

Int32 NET_ReadInt32(Int32** Ptr)
{
	Int32 Ret;
	
	if (!Ptr || !(*Ptr))
		return 0;
	
	Ret = **Ptr;
	(*Ptr)++;
	return NATIVE32(Ret);
}

UInt8 NET_ReadUInt8(UInt8** Ptr)
{
	UInt8 Ret;
	
	if (!Ptr || !(*Ptr))
		return 0;
	
	Ret = **Ptr;
	(*Ptr)++;
	return Ret;
}

UInt16 NET_ReadUInt16(UInt16** Ptr)
{
	UInt16 Ret;
	
	if (!Ptr || !(*Ptr))
		return 0;
	
	Ret = **Ptr;
	(*Ptr)++;
	return NATIVE16(Ret);
}

UInt32 NET_ReadUInt32(UInt32** Ptr)
{
	UInt32 Ret;
	
	if (!Ptr || !(*Ptr))
		return 0;
	
	Ret = **Ptr;
	(*Ptr)++;
	return NATIVE32(Ret);
}

void NET_WriteInt8(Int8** Ptr, Int8 Val)
{
	if (!Ptr || !(*Ptr))
		return;
	**Ptr = Val;
	(*Ptr)++;
}

void NET_WriteInt16(Int16** Ptr, Int16 Val)
{
	if (!Ptr || !(*Ptr))
		return;
	**Ptr = NATIVE16(Val);
	(*Ptr)++;
}

void NET_WriteInt32(Int32** Ptr, Int32 Val)
{
	if (!Ptr || !(*Ptr))
		return;
	**Ptr = NATIVE32(Val);
	(*Ptr)++;
}

void NET_WriteUInt8(UInt8** Ptr, UInt8 Val)
{
	if (!Ptr || !(*Ptr))
		return;
	**Ptr = Val;
	(*Ptr)++;
}

void NET_WriteUInt16(UInt16** Ptr, UInt16 Val)
{
	if (!Ptr || !(*Ptr))
		return;
	**Ptr = NATIVE16(Val);
	(*Ptr)++;
}

void NET_WriteUInt32(UInt32** Ptr, UInt32 Val)
{
	if (!Ptr || !(*Ptr))
		return;
	**Ptr = NATIVE32(Val);
	(*Ptr)++;
}

